<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 06/10/2005 *
 * ===================                          Last change: 05/18/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-sponsor_login.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Login form and password resending for sponsor    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Loginformular und Neues Passwort fuer Sponsor    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('guest', __FILE__);

if ((!isExtensionActive('sponsor'))) {
	displayMessage('{%pipe,generateExtensionInactiveNotInstalledMessage=sponsor%}');
	return;
} elseif (isSponsor()) {
	// Is already a logged-in sponsor
	redirectToUrl('modules.php?module=sponsor');
}

$mode = '';
if (isGetRequestParameterSet('mode')) {
	// A "special" mode of the login system was requested
	switch (getRequestParameter('mode')) {
		case 'activate' : $mode = 'activate';  break; // Activation link requested
		case 'lost_pass': $mode = 'lost_pass'; break; // Request new password
	} // END - switch
} // END - if

// Check if hash for confirmation of email address is given...
if (isGetRequestParameterSet('hash')) {
	// Lookup sponsor
	$result = SQL_QUERY_ESC("SELECT
	`id`, `status`, `gender`, `surname`, `family`,
	`company`, `position`, `tax_ident`,
	`street_nr1`, `street_nr2`, `country`, `zip`, `city`, `email`, `phone`, `fax`, `cell`,
	`points_amount` AS `points`, `last_payment`, `last_currency`
FROM
	`{?_MYSQL_PREFIX?}_sponsor_data`
WHERE
	`hash`='%s' AND (
		`status`='UNCONFIRMED' OR
		`status`='EMAIL'
	)
LIMIT 1", array(getRequestParameter('hash')), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 1) {
		// Sponsor found, load his data...
		$data = SQL_FETCHARRAY($result);

		// Unconfirmed account or changed email address?
		if ($data['status'] == 'UNCONFIRMED') {
			// Set account to pending
			SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_sponsor_data`
SET
	`status`='PENDING',
	`hash`=NULL
WHERE
	`id`=%s AND
	`hash`='%s' AND
	`status`='UNCONFIRMED'
LIMIT 1",
				array(
					bigintval($data['id']),
					getRequestParameter('hash')
				), __FILE__, __LINE__);

			// Check on success
			if (!SQL_HASZEROAFFECTED()) {
				// Prepare mail and send it to the sponsor
				$message = loadEmailTemplate('sponsor_pending', $data);
				sendEmail($data['email'], '{--SPONSOR_ACCOUNT_PENDING_SUBJECT--}', $message);

				// Send email to admin
				sendAdminNotification('{--ADMIN_NEW_SPONSOR--}', 'admin_sponsor_pending', $data);

				// Sponsor account set to pending
				displayMessage('{--SPONSOR_ACCOUNT_IS_PENDING--}');
			} else {
				// Could not unlock account!
				displayMessage('{--SPONSOR_ACCOUNT_PENDING_FAILED--}');
			}
		} elseif ($data['status'] == 'EMAIL') {
			// Changed email adress need to be confirmed
			SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_sponsor_data`
SET
	`status`='CONFIRMED',
	`hash`=NULL
WHERE
	`id`=%s AND
	`hash`='%s' AND
	`status`='EMAIL'
LIMIT 1",
				array(bigintval($data['id']), getRequestParameter('hash')), __FILE__, __LINE__);

			// Check on success
			if (!SQL_HASZEROAFFECTED()) {
				// Sponsor account is unlocked again
				displayMessage('{--SPONSOR_ACCOUNT_IS_CONFIRMED_AGAIN--}');
			} else {
				// Could not unlock account!
				displayMessage('{--SPONSOR_ACCOUNT_EMAIL_FAILED--}');
			}
		} else {
			// ??? Other status?
			displayMessage('{--SPONSOR_ACCOUNT_STATUS_FAILED--}');
		}
	} else {
		// No sponsor found
		displayMessage('{%message,SPONSOR_ACCOUNT_404=' . getRequestParameter('hash') . '%}');
	}

	// Free memory
	SQL_FREERESULT($result);
} elseif ($mode == 'activate') {
	// Send activation link again
	if (isFormSent()) {
		// Check submitted data
		if (!isPostRequestParameterSet('email')) unsetPostRequestParameter('ok');
	}

	if (isFormSent()) {
		// Check email
		$result = SQL_QUERY_ESC("SELECT
	`id`, `hash`, `status`, `remote_addr`, `gender`, `surname`, `family`,
	UNIX_TIMESTAMP(`sponsor_created`) AS `sponsor_created`
FROM
	`{?_MYSQL_PREFIX?}_sponsor_data`
WHERE
	`email`='%s' AND
	(`status`='UNCONFIRMED' OR `status`='EMAIL')
LIMIT 1",
		array(postRequestParameter('email')), __FILE__, __LINE__);

		// Entry found?
		if (SQL_NUMROWS($result) == 1) {
			// Unconfirmed sponsor account found so let's load the requested data
			$data = SQL_FETCHARRAY($result);

			// Translate some data
			$data['sponsor_created'] = generateDateTime($data['sponsor_created']);

			// Prepare email and send it to the sponsor
			if ($data['status'] == 'UNCONFIRMED') {
				// Unconfirmed accounts
				$message_sponsor = loadEmailTemplate('sponsor_activate', $data);
			} else {
				// Confirmed email address
				$message_sponsor = loadEmailTemplate('sponsor_email', $data);
			}
			sendEmail(postRequestParameter('email'), '{--SPONSOR_ACTIVATION_LINK_SUBJECT--}', $message_sponsor);

			// Output message
			displayMessage('{--SPONSOR_ACTIVATION_LINK_SENT--}');
		} else {
			// No account found or not UNCONFIRMED
			displayMessage('{--SPONSOR_ACTIVATION_LINK_404--}');
		}

		// Free memory
		SQL_FREERESULT($result);
	} else {
		// Load form
		loadTemplate('guest_sponsor_activate');
	}
} elseif ($mode == 'lost_pass') {
	// Send new password
	if (isFormSent()) {
		// Check submitted data
		if (!isPostRequestParameterSet('email')) unsetPostRequestParameter('ok');
	} // END - if

	if (isFormSent()) {
		// Check email
		$result = SQL_QUERY_ESC("SELECT
	`id`, `hash`, `remote_addr`, `gender`, `surname`, `family`,
	UNIX_TIMESTAMP(`sponsor_created`) AS `sponsor_created`
FROM
	`{?_MYSQL_PREFIX?}_sponsor_data`
WHERE
	`email`='%s' AND
	`id`=%s AND
	`status`='CONFIRMED'
LIMIT 1",
		array(postRequestParameter('email'), bigintval(postRequestParameter('id'))), __FILE__, __LINE__);

		// Entry found?
		if (SQL_NUMROWS($result) == 1) {
			// Unconfirmed sponsor account found so let's load the requested data
			$DATA = SQL_FETCHARRAY($result);

			// Generate password/translate some data
			$DATA['password']        = generatePassword();
			$DATA['sponsor_created'] = generateDateTime($DATA['sponsor_created']);

			// Prepare email and send it to the sponsor
			$message_sponsor = loadEmailTemplate('sponsor_lost', $DATA);
			sendEmail(postRequestParameter('email'), '{--SPONSOR_LOST_PASSWORD_SUBJECT--}', $message_sponsor);

			// Update password
			SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_sponsor_data`
SET
	`password`='%s'
WHERE
	`id`=%s
LIMIT 1",
				array(md5($DATA['password']), bigintval($DATA['id'])), __FILE__, __LINE__);

			// Output message
			displayMessage('{--SPONSOR_LOST_PASSWORD_SENT--}');
		} else {
			// No account found or not UNCONFIRMED
			displayMessage('{--SPONSOR_LOST_PASSWORD_404--}');
		}

		// Free memory
		SQL_FREERESULT($result);
	} else {
		// Load form
		loadTemplate('guest_sponsor_lost');
	}
} elseif (isFormSent()) {
	// Check status and login data ...
	$result = SQL_QUERY_ESC("SELECT
	`status`
FROM
	`{?_MYSQL_PREFIX?}_sponsor_data`
WHERE
	`id`=%s AND
	`password`='%s'
LIMIT 1",
	array(
		bigintval(postRequestParameter('sponsor_id')),
		md5(postRequestParameter('password'))
	), __FILE__, __LINE__);

	if (SQL_NUMROWS($result) == 1) {
		// Okay, first login data check passed, now has he/she an approved (CONFIRMED) account?
		list($status) = SQL_FETCHROW($result);
		if ($status == 'CONFIRMED') {
			// Is confirmed so both is fine and we can continue with login procedure
			$login = ((setSession('sponsor_id'  , bigintval(postRequestParameter('sponsor_id')))) &&
			(setSession('sponsor_pass', md5(postRequestParameter('password'))           ))
			);

			if ($login === true) {
				// Cookie setup successfull so we can forward to sponsor area
				redirectToUrl('modules.php?module=sponsor');
			} else {
				// Cookie setup failed!
				displayMessage('{--SPONSOR_COOKIE_SETUP_FAILED--}');

				// Login formular and other links
				loadTemplate('guest_sponsor_login');
			}
		} else {
			// Status is not fine
			displayMessage('{--SPONSOR_LOGIN_FAILED_' . strtoupper($status) . '--}');

			// Login formular and other links
			loadTemplate('guest_sponsor_login');
		}
	} else {
		// Account missing or wrong pass! We shall not find this out for the "cracker folks"...
		displayMessage('{--SPONSOR_LOGIN_FAILED_404_WRONG_PASS--}');

		// Login formular and other links
		loadTemplate('guest_sponsor_login');
	}

	// Free memory
	SQL_FREERESULT($result);
} else {
	// Login formular and other links
	loadTemplate('guest_sponsor_login');
}

// [EOF]
?>
